`timescale 1ns/1ps 

module psram_test(
	clk,
	rst_n,
	init_done,
	addr,
	cmd,
	cmd_en,
	wr_data,
	rd_data,
	rd_data_valid,
	data_mask,
	  
	start,
	uart_txout,
	uart_txout_req,
	uart_txout_ack           
 );

///////psram interface

input                           clk;
input                           rst_n;
input                           init_done;
output                          cmd;
/////0 read
/////1 write
output                          cmd_en;
input [4*16-1:0]                rd_data;         //DQ_WIDTH=16
input                           rd_data_valid;



output[4*16-1:0]                wr_data;        //DQ_WIDTH=16
output reg [21-1:0]             addr;            //ADDR_WIDTH=21
output reg [7:0]                data_mask;      //CS_WIDTH=2, MASK_WIDTH=8


/////////////////the input the key  start write,display is read
////////////////
input                           start;
 
output                          uart_txout_req;
output [7:0]                    uart_txout;
input							uart_txout_ack;
////////////////////////////////





reg   [6:0]                     wr_cnt;
reg                             cmd;
reg                             cmd_en;
//reg   [4*DQ_WIDTH-1:0] rd_data;
reg   [4*16-1:0]                wr_data;        //DQ_WIDTH=16

// start sync
reg [2:0]                       start_syn;
reg [9:0]                       sys_cnt;
    
wire                            start_pos;


wire [63:0] mem_data [0:7]; 

 
assign  mem_data[0] = 64'h8808_7728_e878_f685;
assign  mem_data[1] = 64'h1505_5a21_25b5_fa1a;
assign  mem_data[2] = 64'h2404_0bf2_d464_ab25;
assign  mem_data[3] = 64'h3303_45e3_f173_213a;
assign  mem_data[4] = 64'h42e2_6694_42b2_f245;
assign  mem_data[5] = 64'h5101_6735_d351_435a;
assign  mem_data[6] = 64'h6000_0826_d440_f465;
assign  mem_data[7] = 64'h7606_8947_86b6_357a;

always@(posedge clk or negedge rst_n)
begin
  if (!rst_n)
	start_syn <= 3'b000;
  else
	start_syn <= {start_syn[1:0], ~start};
end

assign start_pos = start_syn[1] & ~start_syn[2];///falling

 
reg psram_test_enable;	
always@(posedge clk or negedge rst_n)
if(!rst_n)	
	psram_test_enable <= 0;
else if(start_pos)
	psram_test_enable <= 1;
else if(wr_cnt == 7'b1111111)
	psram_test_enable <= 0;
	
//////////////////////////////////////////
always@(posedge clk or negedge rst_n)
if(!rst_n)
wr_cnt <= 'b0;
else if(wr_cnt == 7'b1111111)///127？
wr_cnt <= 0;
else if(init_done && psram_test_enable )
wr_cnt <= wr_cnt + 1'b1;

always@(posedge clk or negedge rst_n)
 if(!rst_n)
	begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'b0;
	   wr_data <=  'b0;
	   data_mask<= 'b0;
	end  
 else if(wr_cnt == 'd10)
   begin
	   cmd     <= 1'b1; ////write data，burst mode only 8
	   cmd_en  <= 1'b1;  ///////////
	   addr    <=  'h0;
	   wr_data <=  mem_data[0];   //64'h8808_7728_e878_f685; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd11)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <=  mem_data[1];
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd12)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <=  mem_data[2]; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd13)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <= mem_data[3]; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd14)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <= mem_data[4]; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd15)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <= mem_data[5]; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd16)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <= mem_data[6]; 
	   data_mask<= 'b0;
   end
 else if(wr_cnt == 'd17)
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'h0;
	   wr_data <= mem_data[7];
	   data_mask<= 'b0;
   end

  else if(wr_cnt == 'd55)    //read data
   begin
	   cmd     <= 1'b0;//read
	   cmd_en  <= 1'b1;//
	   addr    <=  'd0;
   end 
 else
   begin
	   cmd     <= 1'b0;
	   cmd_en  <= 1'b0;
	   addr    <=  'b0;
	   wr_data <=  'b0;
   end
////////////////////////////////////////////////////////////////////

//read data


    // read data store
    reg [5:0]                   mem_rdaddr;
    reg [4*16-1:0]              mem_rddata [0:31];    //DQ_WIDTH=16
    reg                         display_en;

    always@(posedge clk or negedge rst_n)
    begin
      if(!rst_n)
        mem_rdaddr <= 6'b000000;
      else if(rd_data_valid)
        mem_rdaddr <= mem_rdaddr + 1'b1;
    end

    always@(posedge clk)
    begin
      if(rd_data_valid)
        mem_rddata[mem_rdaddr] <= rd_data;
    end


	
	reg  uart_out_req;
	reg  uart_out_over;
    always@(posedge clk or negedge rst_n)
    begin
		if(!rst_n)
			uart_out_req <= 1'b0;
		else if(rd_data_valid)
			uart_out_req <= 1'b1;
		else if(uart_out_over)
			uart_out_req <= 0;
    end 
 
  
	
	reg uart_txout_ack_d0;
	reg uart_txout_ack_d1; 
	always @(posedge clk  )
	begin
		uart_txout_ack_d0 <= uart_txout_ack ;
		uart_txout_ack_d1 <= uart_txout_ack_d0; 
	end

	wire uart_txout_ack_rising;
	assign 	uart_txout_ack_rising = ((uart_txout_ack_d1 == 1'b0) &&(uart_txout_ack_d0 == 1'b1));
	
	
	reg[7:0] uart_counter;
    always@(posedge clk or negedge rst_n)
    begin
		if(!rst_n)
			uart_counter <= 0;
		else  if(uart_counter ==64)
            uart_counter <= 0;
       else if(uart_txout_ack_rising ==1)
            uart_counter <= uart_counter+1'd1; 
		else
			uart_counter <= uart_counter ;
	end
	 
	 
    always@(posedge clk or negedge rst_n)
    begin
		 if(!rst_n)
			uart_out_over <= 0;
		else if(uart_counter ==64)
			uart_out_over <= 1;
		else
			uart_out_over <= 0;
	end	
	
	
	reg uart_txen_temp;
	reg[7:0]	uart_txdata_temp;
	always@(posedge clk or negedge rst_n)
    begin
		if(!rst_n)
			begin
				uart_txen_temp   <= 0;
				uart_txdata_temp <= 0;
			end
		else  
			 begin
                if(uart_counter == 64)
                    uart_txen_temp   <= 1'b0;
                else   if(rd_data_valid)
                    uart_txen_temp   <= 1'b1; 
                    
				case(uart_counter[2:0])
					0:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>56;
					1:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>48;
					2:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>40;
					3:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>32;
					4:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>24;
					5:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>16;
					6:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]]>>8;
					7:	uart_txdata_temp <=  mem_rddata[uart_counter[7:3]];
				endcase
			end
	end
	
	assign uart_txout_req =uart_txen_temp;
	assign uart_txout = uart_txdata_temp; 

endmodule

