`timescale 1ns/1ps
module psramwork(
	clk,
	rst_n, 
	start,
	uart_txd,
 
    O_psram_ck,
    O_psram_ck_n,
    IO_psram_rwds,
    O_psram_reset_n,
    IO_psram_dq,
    O_psram_cs_n  
); 
input                       clk;
input                       rst_n;
input                       start; 
output					    uart_txd;

///////////////MUST USE!!!!!!
output[2-1:0]               O_psram_ck;             //CS_WIDTH=2
output[2-1:0]               O_psram_ck_n;           //CS_WIDTH=2
inout [2-1:0]               IO_psram_rwds;          //CS_WIDTH=2
inout [16-1:0]              IO_psram_dq;            //DQ_WIDTH=16
output[2-1:0]               O_psram_reset_n;       //CS_WIDTH=2
output[2-1:0]               O_psram_cs_n;          //CS_WIDTH=2

wire                        init_calib; 

wire [4*16-1:0]             wr_data/* synthesis syn_keep=1 */;        //DQ_WIDTH=16
wire [4*16-1:0]             rd_data/* synthesis syn_keep=1 */;        //DQ_WIDTH=16
wire                        rd_data_valid;
wire                        cmd; 
wire                        cmd_en;
wire [21-1:0]               addr;                   //ADDR_WIDTH=21 
wire [7:0]                  data_mask;              //CS_WIDTH=2, MASK_WIDTH=8

wire                        rst_nn;

wire                        uart_txout_req;
wire [7:0]                  uart_txout;
wire						uart_txout_ack;

wire						clk_x1/* synthesis syn_keep=1 */; 

//`ifdef SIM
assign rst_nn = rst_n;
 
 wire start_delay;
key_debounce u5(
.clk(clk),
.rst_n(1'b1),
.key_1(start_delay),
.key1_n(start)
); 

wire memory_clk;
wire pll_lock; 
 Gowin_rPLL Gowin_rPLL_inst
(
  .clkin(clk),
  .clkout(memory_clk),
  .reset(~rst_nn),
  .lock(pll_lock)
);

 

PSRAM_Memory_Interface_Top u_psram_top(
                      .clk(clk),
                      .memory_clk (memory_clk),
                      .pll_lock(pll_lock),
                      .rst_n(rst_nn),  //rst_n
                      .O_psram_ck(O_psram_ck),
                      .O_psram_ck_n(O_psram_ck_n),
                      .IO_psram_rwds(IO_psram_rwds),
                      .IO_psram_dq(IO_psram_dq),
                      .O_psram_reset_n(O_psram_reset_n),
                      .O_psram_cs_n(O_psram_cs_n),
                      .wr_data(wr_data),
                      .rd_data(rd_data),
                      .rd_data_valid(rd_data_valid),
                      .addr(addr),
                      .cmd(cmd),
                      .cmd_en(cmd_en),
                      .clk_out(clk_x1),//80M
                      .data_mask(data_mask),
                      .init_calib(init_calib)
                     );
psram_test u_test(
                  .clk(clk_x1),
                  .rst_n(rst_nn), //rst_n
                  .init_done(init_calib),
                  .cmd(cmd),
                  .cmd_en(cmd_en),
                  .addr(addr),
                  .wr_data(wr_data),
                  .rd_data(rd_data),
                  .rd_data_valid(rd_data_valid), 
                  .data_mask(data_mask)	,

				  
                  .start(start_delay),
				  .uart_txout(uart_txout),
				  .uart_txout_req(uart_txout_req),
				  .uart_txout_ack(uart_txout_ack) 	 
                  );
				  
				  
uart_sendout 
#(
	.baud_cnt_const(695)
)
u_uart_sendout
( 
	  .clk(clk_x1),
	  .rst_n(rst_nn), 
	  .txout(uart_txout),
	  .txout_req(uart_txout_req),
	  .txout_ack(uart_txout_ack), 	
	  .txd(uart_txd)
);				  
				  

endmodule
