`timescale 1ns/1ps 
module testpsram_test;

reg                          clk;
reg                          rst_n;
reg                          init_done;
wire                         cmd;
/////0 read
/////1 write
wire                         cmd_en;
reg [4*16-1:0]               rd_data;         //DQ_WIDTH=16
reg                          rd_data_valid;



wire[4*16-1:0]               wr_data;        //DQ_WIDTH=16
wire[21-1:0]                 addr;            //ADDR_WIDTH=21
wire[7:0]                    data_mask;      //CS_WIDTH=2, MASK_WIDTH=8


/////////////////the input the key  start write,display is read
////////////////
reg                         start;
 
wire                        uart_txout_req;
wire [7:0]                  uart_txout;
wire						uart_txout_ack;
////////////////////////////////

psram_test u_test(
                  .clk(clk),
                  .rst_n(rst_n), //rst_n
                  .init_done(init_done),
                  .cmd(cmd),
                  .cmd_en(cmd_en),
                  .addr(addr),
                  .wr_data(wr_data),
                  .rd_data(rd_data),
                  .rd_data_valid(rd_data_valid), 
                  .data_mask(data_mask)	,

				  
                  .start(start),
				  .uart_txout(uart_txout),
				  .uart_txout_req(uart_txout_req),
				  .uart_txout_ack(uart_txout_ack) 	 
                  );
				  
uart_sendout 
#(
	.baud_cnt_const(695)
)
u_uart_sendout
( 
	  .clk(clk),
	  .rst_n(rst_n), 
	  .txout(uart_txout),
	  .txout_req(uart_txout_req),
	  .txout_ack(uart_txout_ack), 	
	  .txd(uart_txd)
);					  
				  
initial
begin
	clk  = 0;
	rst_n= 0;
	init_done= 0; 
/////0 read 
	rd_data= 0;         //DQ_WIDTH=16
	rd_data_valid= 0;
	start= 0;   
	
#200
	rst_n = 1;
	
#1000;
	init_done =1;
	@(cmd_en & cmd ==1);
	
	#100;
	@(posedge	clk)
		begin
			rd_data <= 64'h8808_7728_e878_f685;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h1505_5a21_25b5_fa1a;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h2404_0bf2_d464_ab25;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h3303_45e3_f173_213a;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h42e2_6694_42b2_f245;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h5101_6735_d351_435a;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h6000_0826_d440_f465;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h7606_8947_86b6_357a;
			rd_data_valid <= 1;
		end
	@(posedge	clk)
		begin
			rd_data <= 64'h0;
			rd_data_valid <= 0;
		end
		
	#1000;	
		
end				  

always #2.5	clk =~clk;

endmodule