`timescale 1ns/1ps
module tb();

parameter DQ_WIDTH = 16;
parameter CS_WIDTH = 2;

reg  					clk,rst_n;
wire [CS_WIDTH-1:0]		O_ck;
wire [CS_WIDTH-1:0]		O_ck_n;
wire [CS_WIDTH-1:0]		IO_rwds;
wire [DQ_WIDTH-1:0]		IO_dq;
wire [CS_WIDTH-1:0] 	O_reset;
wire [CS_WIDTH-1:0] 	O_cs_n;
wire  					init_calib;
wire [7:0] 				seg;
wire 					sw;
wire [3:0] 				seg_en;
wire 					display;
wire [3:0] 				show_data;
wire [8:0] 				out;
wire                    VCC;
assign VCC = 1'b1;

GSR GSR(1'b1);

initial begin
  $fsdbDumpfile("psram.fsdb");
  $fsdbDumpvars;
end

initial
begin
    clk = 0;
    rst_n = 0;
    #25
    rst_n = 1;
   end

always #9.6 clk = ~clk;




psram_syn_top u_syn_top(
                 .clk(clk),
                 .rst_n(rst_n),
                 .O_psram_ck(O_ck),
                 .O_psram_ck_n(O_ck_n),
                 .IO_psram_rwds(IO_rwds),
                 .O_psram_reset_n(O_reset),
                 .IO_psram_dq(IO_dq),
                 .O_psram_cs_n(O_cs_n),
                 .init_calib(init_calib),
                 .seg(seg),
                 .sw(sw),
                 .seg_en(seg_en),
                 .display(display),
                 .show_data(show_data),
                 .out(out)                 
                 );

/*	
        W955D8MKY psram_mode0(
          .resetb           (O_reset[0]),
          .clk              (O_ck[0]),
          .clk_n            (O_ck_n[0]),
          .ceb              (O_cs_n[0]),
          .adq              (IO_dq[7:0]),
          .rwds             (IO_rwds[0]),
          .VCC              (VCC),
          .VSS              (1'b0) 
        );
      
       W955D8MKY psram_model(
          .resetb           (O_reset[1]),
          .clk              (O_ck_n[1]),
          .clk_n            (O_ck[1]),
          .ceb              (O_cs_n[1]),
          .adq              (IO_dq[15:8]),
          .rwds             (IO_rwds[1]),
          .VCC              (VCC),
          .VSS              (1'b0) 
        );
*/
       initial
begin
force tb.O_cs_n[1:0] = 2'b11;//force tb.O_cs_n[0] = 1'b1;
#63575;
release tb.O_cs_n;
end
initial
begin
force tb.VCC = 2'b00;//force tb.O_cs_n[0] = 1'b1;
#401750;
release tb.VCC;
end 

endmodule

